#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <math.h>

#ifndef __MOTEUR_
#define __MOTEUR_


#define AdrMot1 0x308
#define AdrMot2 0x309
#define AdrReg	0x30A

#define Vmax	254

int	StatutReg=0;


/************************************
		Met la Led 1  1
*************************************/
void Led1_1()
{
	StatutReg=StatutReg&0x7F;
	outportb (AdrReg,StatutReg);
}


/************************************
		Met la Led 1  0
*************************************/
void Led1_0()
{
	StatutReg=StatutReg|0x80;
	outportb (AdrReg,StatutReg);
}


/************************************
		Met la Led 2  1
*************************************/
void Led2_1()
{
	StatutReg=StatutReg&0xBF;
	outportb (AdrReg,StatutReg);
}


/************************************
		Met la Led 2  0
*************************************/
void Led2_0()
{
	StatutReg=StatutReg|0x40;
	outportb (AdrReg,StatutReg);
}


/************************************
	Met le Reset du moteur 1  0
*************************************/
void RstMot1_0()
{
	StatutReg=StatutReg&0xEF;
	outportb (AdrReg,StatutReg);
}


/************************************
	Met le Reset du moteur 1  1
*************************************/
void RstMot1_1()
{
	StatutReg=StatutReg|0x10;
	outportb (AdrReg,StatutReg);
}


/************************************
	Met le Reset du moteur 2  0
*************************************/
void RstMot2_0()
{
	StatutReg=StatutReg&0xDF;
	outportb (AdrReg,StatutReg);
}


/************************************
Met le Reset du moteur 2  1
*************************************/
void RstMot2_1()
{
	StatutReg=StatutReg|0x20;
	outportb (AdrReg,StatutReg);
}


/************************************
	Met le sens du moteur 1  0
*************************************/
void SensMot1_0()
{
	if ((StatutReg & 0x04)!=0)
	{
		StatutReg=StatutReg&0xFB;
		outportb (AdrReg,StatutReg);
	}
}


/************************************
	Met le sens du moteur 1  1
*************************************/
void SensMot1_1()
{
	if ((StatutReg & 0x04)==0)
	{
		StatutReg=StatutReg|0x04;
		outportb (AdrReg,StatutReg);
	}
}


/************************************
	Met le sens du moteur 2  0
*************************************/
void SensMot2_0()
{
	if ((StatutReg & 0x08) !=0);
	{
		StatutReg=StatutReg&0xF7;
		outportb (AdrReg,StatutReg);
	}

}


/************************************
	Met le sens du moteur 2  1
*************************************/
void SensMot2_1()
{
	if ((StatutReg & 0x08) ==0);
	{
		StatutReg=StatutReg|0x08;
		outportb (AdrReg,StatutReg);
	}

}


/************************************
	Renvoit le sens du moteur 1
*************************************/
int SensMot1()
{
/*	int i;
	int n=0;
	for (i=0;i<3;i++)
		if ((inportb (AdrMot1) & 128) != 0) n++;
	if (n<2)  return (0); else	return (1); */

	if ((inportb (AdrMot1) & 128) == 0) return (0);
	return (1);
}


/************************************
	Renvoit le sens du moteur 2
*************************************/
int SensMot2()
{
/*	int i;
	int n=0;
	for (i=0;i<3;i++)
		if ((inportb (AdrMot2) & 128) != 0) n++;
	if (n<2)  return (0); else	return (1); */

	if ((inportb (AdrMot2) & 128) == 0) return (0);
	return (1);

}


/************************************
	Met le RST du codeur 1  1
*************************************/
void RstCod1_1()
{
	StatutReg=StatutReg|0x01;
	outportb (AdrReg,StatutReg);
}



/************************************
	Met le RST du codeur 1  0
*************************************/
void RstCod1_0()
{
	StatutReg=StatutReg&0xFE;
	outportb (AdrReg,StatutReg);
}


/************************************
	Met le RST du codeur 2  1
*************************************/
void RstCod2_1()
{
	StatutReg=StatutReg|0x02;
	outportb (AdrReg,StatutReg);
}


/************************************
	Met le RST du codeur 2  0
*************************************/
void RstCod2_0()
{
	StatutReg=StatutReg&0xFD;
	outportb (AdrReg,StatutReg);
}


/************************************
	Renvoit le nombre d'imp du codeur G
*************************************/
int CodL ()
{
	int Val=inportb (AdrMot1);
//	return (Val);
	if (Val>127) return (-Val+128);
	return (Val);
}


/************************************
	Renvoit le nombre d'imp du codeur D
*************************************/
int CodR ()
{
	int Val=inportb (AdrMot2);
//	return (Val);
	if (Val>127) return (Val-128);
	return (-Val);
}


/************************************
	Met les deux codeurs  0
*************************************/
void RstCoders ()
{
	RstCod1_1 ();
	RstCod2_1 ();
	RstCod1_0 ();
	RstCod2_0 ();
}


/***********************************
	Initialise la carte moteurs
************************************/
void Init_Moteurs ()
{
	StatutReg=0;
	outportb (AdrReg,StatutReg);
	Led1_0 ();
	Led2_0 ();
	RstMot1_0 ();
	RstMot2_0 ();
	RstMot1_1 ();
	RstMot2_1 ();
	outportb (AdrMot1,85);
	outportb (AdrMot2,85);
	outportb (AdrMot1,0);
	outportb (AdrMot2,0);

	RstCod1_1 ();
	RstCod2_1 ();
	RstCod1_0 ();
	RstCod2_0 ();

}


/**********************************
	Envoit la commande sur le moteur 1
***********************************/
void MoteurR (int Val)
{
	if (Val>0) SensMot1_1 ();
	if (Val<0) SensMot1_0 ();
	if (Val>Vmax) Val=Vmax;
	if (Val<-Vmax) Val=-Vmax;
	outportb (AdrMot1,abs (Val));
}


/**********************************
	Envoit la commande sur le moteur 2
***********************************/
void MoteurL (int Val)
{
	if (Val>0) SensMot2_0 ();
	if (Val<0) SensMot2_1 ();
	if (Val>Vmax) Val=Vmax;
	if (Val<-Vmax) Val=-Vmax;
	outportb (AdrMot2,abs (Val));
}

#endif

