#include <math.h>
#include <stdlib.h>
#include <conio.H>
#include <dos.h>
#include "moteurs.h"

#define INTR 0X1C    /* The clock tick interrupt */
#define l 29.56

int N=0;
int i;
static int CodeurLvieux=0, CodeurRvieux=0;
static int absCodeurLvieux, absCodeurRvieux;
int CodeurL,CodeurR;
int absCodeurL,absCodeurR;
int nbimpulsionL,nbimpulsionR;
double Speed;
double SpeedL, SpeedR;
double SpeedRold,SpeedLold;
double SpeedImp;
double ErreurL, ErreurR;
double OldErreurL=0, OldErreurR=0;
int tab[4650][5];

void interrupt (*oldhandler)(__CPPARGS);
void interrupt handler();
void SetTimerFrequency (float);
void ret_int();
int _abs(int val);

void main(void)
{

	FILE *stream;

	Init_Moteurs ();

	SetTimerFrequency(2);		// Autorise les interruptions val=>tp entre interupt
	oldhandler = getvect(INTR);
	setvect(INTR, handler);


	while(N<4600);
	setvect(INTR, oldhandler);
	ret_int ();


	stream = fopen("data.txt", "w+");
	for(i=0;i<4550;i++)
	{
	   fprintf(stream,"%d\t\t%d\t\t%d\t\t%d\t\t%d\n",tab[i][0],tab[i][1],tab[i][2],tab[i][3],tab[i][4]);
	}
	fclose(stream);
}

/*******************************
programme d'interruption
********************************/
void interrupt handler()
{

	disable();
	N++;
	Speed=0;

	CodeurR= CodR ();//recupere la valeur du codeur droit
	CodeurL= CodL ();//recupere la valeur du codeur gauche

	absCodeurL =_abs(CodeurL);
	absCodeurR =_abs(CodeurR);
	absCodeurLvieux=_abs(CodeurLvieux);
	absCodeurRvieux=_abs(CodeurRvieux);

	//distance parcourue depuis
	//la derniere utilisation de la fonction (roue droite et gauche)

	//si on realise le tour des capteur qui passent de 127 a 0
	if(absCodeurL<absCodeurLvieux)absCodeurL=absCodeurL+127;
	if(absCodeurR<absCodeurRvieux)absCodeurR=absCodeurR+127;

	nbimpulsionL = absCodeurL-absCodeurLvieux;
	nbimpulsionR = absCodeurR-absCodeurRvieux;

	//si marche arriere =>on veut des impulsion en moins(on a recul!):
	if( CodeurL < 0 ) nbimpulsionL = -nbimpulsionL;
	if( CodeurR < 0 ) nbimpulsionR = -nbimpulsionR;
	if( (CodeurL == 0) && (CodeurLvieux<0) ) nbimpulsionL =-nbimpulsionL;
	if( (CodeurR == 0) && (CodeurRvieux<0) ) nbimpulsionR =-nbimpulsionR;
	CodeurLvieux = CodeurL;
	CodeurRvieux = CodeurR;


	//Les paliers 0 31 62 93 124
	if (N<0) Speed=0;
	else if (N<500) Speed=-124;	//-124 = 0 - 124
	else if (N<1000) Speed=-62;	//-62 = -124 + 62
	else if (N<1500) Speed=62;  //62  =	-62 + 124
	else if (N<2000) Speed=124; //124 =	62 + 62
	else if (N<2500) Speed=-93; //-93 =	124 - 217
	else if (N<3000) Speed=-31; //-31 =	-93 + 62
	else if (N<3500) Speed=93;  //93= -31 + 124
	else if (N<4000) Speed=31;  //31= 93 - 62
	else if (N<4500) Speed=0;

	tab[N][0]=Speed;
	tab[N][1]=CodeurR;
	tab[N][3]=CodeurL;
	tab[N][2]=nbimpulsionR;
	tab[N][4]=nbimpulsionL;

	MoteurL(Speed);
	MoteurR(Speed);

	enable();
	oldhandler();
}


/*******************************
 Regle la frequence de l'horloge
*******************************/
void SetTimerFrequency (float ms)
{
	float base=1193180.0;
	unsigned short word;

	base*=(ms/1000.0);
	word=(unsigned short)base;

	outportb(0x43,0x3C);

	outportb(0x40,word);
	outportb(0x40,word>>8);
}


/**************************************
  Remet le timer dans son tat normal
**************************************/
void ret_int ()
{
	outportb(0x43,0x3C);
	outportb(0x40,0xFF);
	outportb(0x40,0xFF);
}


/**************************************
		Valeur absolue
**************************************/
int  _abs(int val)
{
	if (val<0) return -val;
	return val;

}
