#include "control.h"
#define INTR 0X1C    /* The clock tick interrupt */
#define l 29.56


void interrupt (*oldhandler)(__CPPARGS);

int _abs(int val);

/*******************************
programme d'interruption
********************************/
void interrupt handler()
{

	disable();

	NbIt++;

	CodeurR= CodR ();//recupere la valeur du codeur droit
	CodeurL= CodL ();//recupere la valeur du codeur gauche
	absCodeurL =_abs(CodeurL);
	absCodeurR =_abs(CodeurR);
	absCodeurLvieux=_abs(CodeurLvieux);
	absCodeurRvieux=_abs(CodeurRvieux);

	//distance parcourue depuis
	//la derniere utilisation de la fonction (roue droite et gauche)

	//si on realise le tour des capteur qui passent de 127 a 0

	if(absCodeurL<absCodeurLvieux)absCodeurL=absCodeurL+127;
	if(absCodeurR<absCodeurRvieux)absCodeurR=absCodeurR+127;

	nbimpulsionL = absCodeurL-absCodeurLvieux;
	nbimpulsionR = absCodeurR-absCodeurRvieux;

	//si marche arriere =>on veut des impulsion en moins(on a recul!):
	if( CodeurL < 0 ) nbimpulsionL = -nbimpulsionL;
	if( CodeurR < 0 ) nbimpulsionR = -nbimpulsionR;
	if( (CodeurL == 0) && (CodeurLvieux<0) ) nbimpulsionL =-nbimpulsionL;
	if( (CodeurR == 0) && (CodeurRvieux<0) ) nbimpulsionR =-nbimpulsionR;
	CodeurLvieux = CodeurL;
	CodeurRvieux = CodeurR;

	/******************************
	 * asservissement en position *
	/******************************/

	// Met  jour la position du robot:
	SpeedWheelRadR = 0.0008765604520*(double)nbimpulsionR; //Convertion en rad
	SpeedWheelRadL = 0.0008765604520*(double)nbimpulsionL;

	Cp = cos(PsiRobot);
	Sp = sin(PsiRobot);

	//calcul de la position du robot en XY et angle
	Xrobot   -=  ((WheelRayonL*SpeedWheelRadL)/2.0) * Cp + ((WheelRayonR*SpeedWheelRadR)/2.0) * Cp;
	Yrobot   +=  ((WheelRayonL*SpeedWheelRadL)/2.0) * Sp + ((WheelRayonR*SpeedWheelRadR)/2.0) * Sp;
	PsiRobot += (WheelRayonR*SpeedWheelRadR - WheelRayonL*SpeedWheelRadL)/(WheelAxis);

	//calcul pour garder la valeur de l'angle du robot entre -Pi et Pi
	if (PsiRobot >PI) { PsiRobot-=2.0*PI; }
	if (PsiRobot<-PI) { PsiRobot+=2.0*PI; }

	//recuperation de l'angle vers lequel est le point cibl
	if(Xt[nbpts]-Xrobot!=0)
	{
		TetaD=(atan2(Yt[nbpts]-Yrobot,Xt[nbpts]-Xrobot))-PI;
		Teta=PsiRobot+TetaD;
	}
	else// si x=0 la fonction atan2 tant vers l'infini
	{  //on met alors la valeur Pi/2 ou -Pi/2

		if(Yt[nbpts]-Yrobot>0) Teta=1.57079632;
		else Teta=-1.57079632;
	}

	//calcul poru garder la valeur de l'angle vers lequel il faut aller entre -Pi et Pi
	if (Teta >PI) { Teta-=2.0*PI; }
	if (Teta<-PI) { Teta+=2.0*PI; }
	//defini grace au theoreme de pythagore la distance qui separe le robot de la cible
	//et la precision du robot
	if((Xrobot-Xt[nbpts])*(Xrobot-Xt[nbpts])+(Yrobot-Yt[nbpts])*(Yrobot-Yt[nbpts])<=2500)
	{
		if(nbpts<2)//tant que le nombre de point n'est pas atteint
			nbpts++;
		else
			flagtarget=1;//si flagtarget=1 alors le prog s'arrete
	}

	MoteurL(60-(int)((double)K*Teta));//defini la vitesse initiale du robot +la correction
	MoteurR(60+(int)((double)K*Teta));

// //	MoteurL(40);
// 	//MoteurR(40);

	enable();
	oldhandler();
}

/*******************************
 Regle la frequence de l'horloge
*******************************/
void SetTimerFrequency (float ms)
{
	float base=1193180.0;
	unsigned short word;

	base*=(ms/1000.0);
	word=(unsigned short)base;

	outportb(0x43,0x3C);

	outportb(0x40,word);
	outportb(0x40,word>>8);
}

/**************************************
   Initialisation des interruptions
**************************************/
void Init_PID()
{
	SetTimerFrequency(2);		// Autorise les interruptions val=>tp entre interupt
	oldhandler = getvect(INTR);
	setvect(INTR, handler);
}

/**************************************
  Remet le timer dans son tat normal
**************************************/
void ret_int ()
{
	outportb(0x43,0x3C);
	outportb(0x40,0xFF);
	outportb(0x40,0xFF);
}

/*************************
Interdit les interruptions
*************************/
void Stop_PID()
{

	setvect(INTR, oldhandler);
	ret_int ();
	MoteurL (0);
	MoteurR (0);
}

int  _abs(int val)
{
	if (val<0) return -val;
	return val;

}


