#include <math.h>
#include <stdlib.h>
#include <conio.H>
#include <dos.h>
#include "moteurs.h"


#define INTR 0X1C    /* The clock tick interrupt */
#define l 29.56
#define Ki 0.05
#define Kp 4
#define Commande 4	//de 0 a 65


int N=0;
static int CodeurLvieux=0, CodeurRvieux=0;
static int absCodeurLvieux, absCodeurRvieux;
int CodeurL,CodeurR;
int absCodeurL,absCodeurR;
int nbimpulsionL,nbimpulsionR;
double SpeedL, SpeedR;
double SpeedRold,SpeedLold;
double SpeedImp;
double ErreurL, ErreurR;
double OldErreurL=0, OldErreurR=0;


void interrupt (*oldhandler)(__CPPARGS);
void interrupt handler();
void SetTimerFrequency (float);
void ret_int();
int _abs(int val);


void main(void)
{
	Init_Moteurs ();	//initialise les moteurs
	SetTimerFrequency(2);		// Autorise les interruptions val=>tp entre interupt
	oldhandler = getvect(INTR);
	setvect(INTR, handler);

	while(N<8000)
	{
		if(SpeedL==127)printf("T  AU MAX !!!!\n");
		else printf("Commande: %d\t\troue gauche: %d\t\troue droite: %d\n",(int)SpeedImp,(int)nbimpulsionL,(int)nbimpulsionR);
	}
	MoteurL(0);
	MoteurR(0);


	setvect(INTR, oldhandler);
	ret_int ();
}

/*******************************
programme d'interruption
********************************/
void interrupt handler()
{

	disable();
	N++;

	CodeurR= CodR ();//recupere la valeur du codeur droit
	CodeurL= CodL ();//recupere la valeur du codeur gauche

	absCodeurL =_abs(CodeurL);
	absCodeurR =_abs(CodeurR);
	absCodeurLvieux=_abs(CodeurLvieux);
	absCodeurRvieux=_abs(CodeurRvieux);

	//distance parcourue depuis
	//la derniere utilisation de la fonction (roue droite et gauche)
	//si on realise le tour des capteur qui passent de 127 a 0
	if(absCodeurL<absCodeurLvieux)absCodeurL=absCodeurL+127;
	if(absCodeurR<absCodeurRvieux)absCodeurR=absCodeurR+127;

	nbimpulsionL = absCodeurL-absCodeurLvieux;
	nbimpulsionR = absCodeurR-absCodeurRvieux;

	//si marche arriere =>on veut des impulsion en moins(on a recul!):
	if( CodeurL < 0 ) nbimpulsionL = -nbimpulsionL;
	if( CodeurR < 0 ) nbimpulsionR = -nbimpulsionR;
	if( (CodeurL == 0) && (CodeurLvieux<0) ) nbimpulsionL =-nbimpulsionL;
	if( (CodeurR == 0) && (CodeurRvieux<0) ) nbimpulsionR =-nbimpulsionR;
	CodeurLvieux = CodeurL;
	CodeurRvieux = CodeurR;

	SpeedImp=Commande;

	ErreurL=SpeedImp-nbimpulsionL ;
	ErreurR=SpeedImp-nbimpulsionR ;
	SpeedL = SpeedLold + (Ki-Kp)*OldErreurL + Kp*ErreurL;
	SpeedR = SpeedRold + (Ki-Kp)*OldErreurR + Kp*ErreurR;
	if(SpeedL>127)SpeedL=127;
	if(SpeedR>127)SpeedR=127;
	if(SpeedL<-127)SpeedL=-127;
	if(SpeedR<-127)SpeedR=-127;
	OldErreurL = ErreurL;
	OldErreurR = ErreurR;
	SpeedRold=SpeedR;
	SpeedLold=SpeedL;

	MoteurL((int)SpeedL);
	MoteurR((int)SpeedR);

	enable();
	oldhandler();
}

/*******************************
 Regle la frequence de l'horloge
*******************************/
void SetTimerFrequency (float ms)
{
	float base=1193180.0;
	unsigned short word;

	base*=(ms/1000.0);
	word=(unsigned short)base;

	outportb(0x43,0x3C);

	outportb(0x40,word);
	outportb(0x40,word>>8);
}


/**************************************
  Remet le timer dans son tat normal
**************************************/
void ret_int ()
{
	outportb(0x43,0x3C);
	outportb(0x40,0xFF);
	outportb(0x40,0xFF);
}

/**************************************
		Valeur absolue
**************************************/
int  _abs(int val)
{
	if (val<0) return -val;
	return val;

}
