#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include "i2c.h"

#define AdresPince 0x00
#define SwitchAdr	0x42
#define TempoOuvrirFermer 100


void Initialisation (void);
int Init_Switch(void);
int Jack(void);	//0 => Rien, 1 => Jack, X<0 => Erreur
void MonterDescendrePince (int val);	//0 => descendre, 1=> monter
void OuvrirFermerPince (int val);	//0 => fermer, 1 => ouvrir
int BarInfra(void);	//0 => Rien, 1 => Objet


void Initialisation (void)
{
	I2C_Init();
	MonterDescendrePince (1);	//Monte la pince dans le robot
	OuvrirFermerPince (1);	//Ouvre la pince
}

int Init_Switch(void)
{
	return (I2C_Send(SwitchAdr,0xFF));
}

/**********************************************
  Fonction qui teste la prsence du Jack

Renvoie :	1  si le jack est enfonc
			0  si le jack n'est pas enfonc
			<0 en cas de problme
**********************************************/
int Jack(void)
{
	int retourjack;

	retourjack=I2C_Receive(SwitchAdr);	//int I2C_Receive(char)
	if (retourjack<0) return (retourjack); //si ret ngatif renvoie un nombre ngatif
	if (retourjack&0x04) return (1);
	return (0);
}

void MonterDescendrePince (int val)	//0 pour descendre la pince, 1 pour la monter
{
	int Registre_Pince;

	Registre_Pince = I2C_Receive (AdresPince);
	if (val!=0) I2C_Send (AdresPince,Registre_Pince&=0xFD);	//Monte la pince
	else I2C_Send (AdresPince,Registre_Pince|=0x02);	//Descend la pince
}

void OuvrirFermerPince (int val)	//0 pour la fermer, 1 pour l'ouvrir
{
	int Registre_Pince;
	int i;

	Registre_Pince = I2C_Receive (AdresPince);
	if (val!=0)
	{
		Registre_Pince|=0x04;	//Indique que l'on va ouvrir la pince
		Registre_Pince|=0x01;	//Allume le moteur
		for(i=0;i<TempoOuvrirFermer;i++)
		{
			I2C_Send (AdresPince,Registre_Pince);
		}
		I2C_Send (AdresPince,Registre_Pince&=0xFE);	//eteinds le moteur
	}
	else
	{
		Registre_Pince&=0xFB;	//Indique que l'on va fermer la pince
		Registre_Pince|=0x01;	//Allume le moteur
		for(i=0;i<TempoOuvrirFermer;i++)
		{
			I2C_Send (AdresPince,Registre_Pince);
		}
		I2C_Send (AdresPince,Registre_Pince&=0xFE);	//eteinds le moteur
	}
}

int BarInfra(void)	//0 pour rien, 1 pour un objet, ngatif pour erreur
{
	int Registre_Infra;

	Registre_Infra=I2C_Receive(SwitchAdr);	//int I2C_Receive(char)
	if (Registre_Infra<0) return (Registre_Infra); //si ret ngatif renvoie un nombre ngatif
	if (Registre_Infra&0x80) return (0);
	return (1);

}