#include <graphics.h>
#include <math.h>
#include <dos.h>
//#include <stdlib.h>

#ifndef __GRAPH_
#define __GRAPH_

#define noir 0
#define vert 2
#define rouge 4
#define rose 5
#define gris 7
#define bleu 9
#define jaune 14
#define blanc 15
#define Pi 3.14159265359

void SwGraphics(void);        				// Passe en mode graphique
void SwText();
void Table07();
void AffPile(double x, double y, char c);
void AffCanette(double x, double y);
void AffBouteille(double x, double y);
void AffRobot(double x, double y, double psi);


/***************************************
Passe en mode graphique
***************************************/
void SwGraphics()
{
	int Gd = DETECT, Gm;
	initgraph(&Gd,&Gm,"");
}

/***************************************
Ferme le mode graphe
***************************************/
void SwText()
{
	closegraph();
}

/***************************************
Affiche la table
***************************************/
void Table07()
{
	int i;	//compteur de boucle

	typedef struct
	{
		double x;
		double y;
		char c;
	}TPoint;

	TPoint Pile[9]={{464,1050,rouge},{1200,625,rouge},{1200,1475,rouge},
	{2536,1050,bleu},{1800,625,bleu},{1800,1475,bleu},{1500,1050,gris},
	{1500,1400,gris},{1500,1750,gris}};

	//Resolution de ecran (639,479):

	//Base en bois en blanc:
	setfillstyle(1,blanc);
	bar (18,28,620,450);
	//Aire de jeu en noire:
	setfillstyle(1,noir);
	bar (19,29,619,449);
	//Aire de la zone bleue:
	setfillstyle(1,bleu);
	bar (19,29,119,129);
	//aire de la zone rouge:
	setfillstyle(1,rouge);
	bar (519,29,619,129);

	//Affichage des 9 endroits avec des piles possibles:
	for( i=0; i<9; i++)
		AffPile(Pile[i].x,Pile[i].y,Pile[i].c);

	AffCanette(1500,350);	//Affichage de la canette au centre
	AffBouteille(1500,700);	//Affichage de la bouteille au centre
   //	AffRobot(800,800,0);	//Affichage du robot
}

/**************************************
Affiche une pile
**************************************/
void AffPile(double x, double y, char c)
{
	int i;
	setcolor(c);
	for(i=0; i<=3; i++)	//3x2 pixels soit un diametre de 30 mm environ
		circle(x/5+19,y/5+29,i);
}

/**************************************
Affiche d'une canette
**************************************/
void AffCanette(double x, double y)
{
	int i;
	setcolor(jaune);
	for(i=0; i<=6; i++) //6x2 pixels soit un diametre de 60 mm
		circle(x/5+19,y/5+29,i);
}

/**************************************
Affiche d'une bouteille
**************************************/
void AffBouteille(double x, double y)
{
	int i;
	setcolor(vert);
	for(i=0; i<=6; i++)	//6x2 pixels soit un diametre de 60 mm
		circle(x/5+19,y/5+29,i);
}


/**************************************
Affiche le robot
**************************************/
void AffRobot(double X, double Y, double psi)
{
	double x,y,XO,YO,XA,YA,XB,YB,XC,YC,XD,YD,XE,YE;

	x = X/5+19;	//1 pixel = 5 mm + dcalage pour etre au centre de l'cran
	y = Y/5+29;

	XA=x;
	YA=y-28;
	XB=x+36;
	YB=y;
	XC=x-36;
	YC=y;
	XD=x;
	YD=y+28;
	XE=20*sin(psi+Pi/2)+x;
	YE=20*cos(psi+Pi/2)+y;
	XO=x;
	YO=y;

	setcolor(rose);
	line((int)XA, (int)YA, (int)XD, (int)YD);
	line((int)XB, (int)YB, (int)XC, (int)YC);
	line((int)XO, (int)YO, (int)XE, (int)YE);

}

#endif